#include "adc.h"


//-------------------------------------------------
// initialisiert den ADC
//-------------------------------------------------
void adc_init()
{
	DIDR0 = (1<<ADC5D) | (1<<ADC4D);				// Digitale Eingnge abschalten
	ADCSRA = (1<<ADATE) | (1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0);	// Frequenzvorteiler 128, Auto Trigger enabled
//	ADCSRB = 0;		// Trigger Source Free Run
	ADMUX |= (1<<REFS0) | (1<<REFS1) | (1<<ADLAR);	// interne Referenzspannung nutzen 	

	//2do auf Interrupt umstellen
}


//-------------------------------------------------
// liest einen ADC-Kanal aus
//-------------------------------------------------
uint8_t ReadChannel(uint8_t mux)
{
	uint8_t result;	// Rckgabevariable
	
	ADCSRA 	|= (1<<ADEN);			// Enable ADC
	ADMUX 	&= 0xf0;				// Kanal zurcksetzen
	ADMUX 	|= mux;					// Kanal waehlen

	ADCSRA 	|= (1<<ADSC);			// eine ADC-Wandlung (Dummy)
  
	while(!(ADCSRA & (1<<ADIF)));	// auf Abschluss der Konvertierung warten (ADIF-bit)

	ADCSRA 	|= (1<<ADIF);			// ADIF lschen (siehe DB, macht sonst die ISR), 
	ADCSRA 	|= (1<<ADSC);			// eine Wandlung "single conversion"
	while(!(ADCSRA & (1<<ADIF)));	// auf Abschluss der Konvertierung warten (ADIF-bit)

	result 	= ADCW>>8;				// Wandlungsergebnisse 

	ADCSRA 	|= (1<<ADIF);			// ADIF lschen
	ADCSRA 	&= ~(1<<ADEN);			// disable ADC

	return result;
}


//-------------------------------------------------
// ADC Conversion Complete ISR
//-------------------------------------------------
SIGNAL (SIG_ADC)
{
	cli();	// global interrupt disable
	//2do
	sei();	// global interrupt enable
}
